unit QRExpert;

{ Before open the QRXMAIN form, you MUST install the components in QRXUTIL.PAS
  Unit. Otherwise you'll receive the message: Class 'TTableListBox' not found. }

interface

uses Forms,
  WinTypes,
  WinProcs,
  Dialogs,
  ExptIntf,
  ToolIntf,
  VirtIntf,
  SysUtils,
  QRXMain,
  QRXUtil;

type
  TQRExpert = class(TIExpert)
{$IfDef Win32}
    function GetName: AnsiString; override;
    function GetComment: AnsiString; override;
    function GetMenuText: AnsiString; override;
    function GetIDString: AnsiString; override;
    function GetGlyph: HICON; override;
    function GetAuthor:AnsiString;
    function GetPage:AnsiString;
{$Else}
    function GetName: string; override;
    function GetComment: string; override;
    function GetMenuText: string; override;
    function GetIDString: string; override;
    function GetGlyph: HBITMAP; override;
{$Endif}
    function GetStyle: TExpertStyle; override; { Style }
    function GetState: TExpertState; override;
    procedure Execute; override; { Launch the Expert }
  end;

procedure Register;

implementation

{$IfNDef Win32}
{$R QRX16.RES}
{$Else}
{$R QRX32.RES}
{$EndIf}

procedure Register;
begin
  RegisterLibraryExpert(TQRExpert.Create);
end;

procedure HandleException;
begin
  ToolServices.RaiseException(ReleaseException);
end;

function TQRExpert.GetName: {$IfDef Win32} AnsiString; {$Else} String; {$EndIf}
begin
  try
    Result := 'QuickReport Expert';
  except
    HandleException;
  end;
end;

function TQRExpert.GetComment:{$IfDef Win32} AnsiString; {$Else} String; {$EndIf}
begin
  try
    Result := 'Creates a new QuickReport form';
  except
    HandleException;
  end;
end;

function TQRExpert.GetMenuText:{$IfDef Win32} AnsiString; {$Else} String; {$EndIf}
begin
  try
    Result := 'QuickReport Expert...';
  except
    HandleException;
  end;
end;

function TQRExpert.GetIDString: {$IfDef Win32} AnsiString; {$Else} String; {$EndIf}
begin
  try
    Result := 'Schmidt.QuickReportExpert'
  except
    HandleException;
  end;
end;

function TQRExpert.GetGlyph: {$IfDef Win32} HICON; {$Else} HBITMAP; {$EndIf}
begin
{$IfDef Win32}
  try
    Result := LoadIcon(HInstance, 'QRX_ICON');
  except
    HandleException;
  end;
{$Else}
  Result := 0; { not need for esStandard }
{$EndIf}
end;

{$IfDef Win32}
function TQRExpert.GetAuthor:AnsiString;
begin
  try
    Result := 'Moacir Schmidt';
  except
    HandleException;
  end;
end;

function TQRExpert.GetPage:AnsiString;
begin
  try
    Result := 'Forms';
  except
    HandleException;
  end;
end;
{$EndIf}

function TQRExpert.GetStyle:TExpertStyle;
begin
  try
{$IfDef Win32}
    Result := esStandard;
{$Else}
    Result := esStandard;
{$EndIf}
  except
    HandleException;
  end;
end;

function TQRExpert.GetState: TExpertState;
begin
  try
    Result := [esEnabled];
  except
    HandleException;
  end;
end;

procedure TQRExpert.Execute;
begin
  try
    QuickRepExpert(ToolServices);
  except
    HandleException;
  end;
end;

begin
end.
